	/* Filename:    .dEvents.js
	 * Description: This application demonstrate the capability of the CS3600 in an event settings such as concerts, clubs, etc.
	 * Copyright:   2013 The Code Corporation. All rights are reserved.
	 * $Title: dEvents $
	 * $Revision: 1.0 $
	 * $Date: 2013-10-08 09:14:02 $
	 * $Author: Dthai 
	 */
	 
	 
	include(".dOptions.js");
	include(".cre.js");
	
	//Override ready.show 
	ready.oldShow = ready.show;
	ready.show = function(text, busy)
	{
		//Do nothing for demo script
	}

	/* Data variables for tradeshow */
	var eventNum = "";
	var demo_Event = true;
	var eventName = "kurban";
	var totalTickets = 0;
	var hourlyTotal = 0;
	var menu = "";
	var checkScan = false;
	var arrayList = [];

	/* Show the default events menu at startup */
	eventDemo = new gui.Menu     ();
	eventDemo.leftSoftkey             = new gui.Softkey  ("Options",    function() { gui.showDialog(eventDemo.options);});
	eventDemo.rightSoftkey            = new gui.Softkey  ("Quit", onEventCancel);

	eventDemo.append                   (new gui.Label    (" "               ));
	eventDemo.append                   (new gui.Label    ("       CR3600  "  ));
	eventDemo.append                   (new gui.Label    ("       Events "  ));
	eventDemo.append                   (new gui.Label    ("   Application    "));
	eventDemo.append                   (new gui.Label    (" "               ));

	eventDemo.options = new gui.Menu;
	eventDemo.options.caption = "Event options";
	eventDemo.options.leftSoftkey	   = new gui.Softkey  ("Select", function() {gui.sendKey(gui.key.enter);} );
	eventDemo.options.rightSoftkey	   = new gui.Softkey  ("Back", onQuit);
	eventDemo.options.append(new gui.MenuItem("Scan tickets", startScan ) );
	eventDemo.options.append(new gui.MenuItem("Hourly totals", showHourlyTotals ) );
	eventDemo.options.append(new gui.MenuItem("Event totals", showEventTotals ) );
	eventDemo.options.append(new gui.MenuItem("Check ticket", checkTicket ) );
	eventDemo.options.append(new gui.MenuItem("Send/Log", fileSave ) );

	menu = eventDemo;
	gui.showDialog(menu);	

	/* Show the initial dialog for events demo */
	function startScan()
	{
		
		start                = new gui.Menu();
		start.caption = "Scan ticket";
		start.rightSoftkey       = new gui.Softkey  ("Back",  function() { gui.showDialog(eventDemo.options);});
		menu = start;
		gui.showDialog(menu);
		
	}; 

	function onCancel()
	{
		menu = demoOptions;
		gui.showDialog(menu);
	}

	/* Gui to show the total hourly attendees */
	function showHourlyTotals()
	{
		hrTotal = new gui.Menu();
		hrTotal.caption = "Hourly totals";
		hrTotal.rightSoftkey       = new gui.Softkey  ("Back",  onOptionCancel);
		menu = hrTotal;
		gui.showDialog(menu);
		var hrTotals = getHourlyTotal();
		gui.show(new gui.Text("Current Hr total: " + hrTotals));
	}

	/* Gui to show the total number of attendees */
	function showEventTotals() 
	{
		eventTotal = new gui.Menu();
		eventTotal.caption = "Event totals";
		eventTotal.rightSoftkey       = new gui.Softkey  ("Back",  onOptionCancel);
		menu = eventTotal;
		gui.showDialog(menu);
		var eventTotalCnt = getEventTotal();
		gui.show(new gui.Text("Event totals: " + eventTotalCnt));	
	}

	/* Check ticket menu */
	function checkTicket()
	{
		
		checkIt                = new gui.Menu();
		checkIt.caption = "Check ticket";
		checkIt.rightSoftkey       = new gui.Softkey  ("Back",  function() {checkScan = false; onOptionCancel();});
		checkScan = true;
		menu = checkIt;
		gui.showDialog(menu);
		
	}

	/* Store data into reader */
	function fileSave()
	{
		fileIt                = new gui.Menu     (                   );
		fileIt.caption = "Saving to file?";
		fileIt.leftSoftkey        = new gui.Softkey  ("Save", onSave);
		fileIt.rightSoftkey       = new gui.Softkey  ("Cancel",  function() {menu = eventDemo.options; gui.showDialog(menu);});

		menu = fileIt;
		gui.showDialog(menu);	
	}

	/* Store data into reader */
	function onSave()
	{
		
		var file = "events_log.demo";
		
		if (arrayList.length != 0 )
		{
			for (var i = 0; i < arrayList.length; i++)
			{			
				storage.append (file, arrayList[i].toString() + '\r\n');
			}
		}
		else 
		{
			reader.beep(4);
			//reader.setDisplayLed(reader.red);
			gui.show(new gui.Text("Error, no data found"));
		}
		
		menu = eventDemo.options;
		gui.show(new gui.Text("Saved"));
		gui.showDialog(menu);
	}

	/* Check to see if a ticket has been scan and for how many times used. */
	function ticketCheck(data)
	{	
			// process data
			var scan = data.data;
			var ct = 0;
			for (var i = 0; i < arrayList.length; i++)
			{
				if (scan.match(arrayList[i].substr(0,19)))
				{
					ct++;
				}			
			}
			
			if (ct == 0)
			{
				reader.beep(4);
				//reader.setDisplayLed(reader.red);
				gui.show(new gui.Text("There are no entry for this ticket."));

			}
			else
			{
				reader.beep(1);
				//reader.setDisplayLed(reader.green);
				gui.show(new gui.Text("Ticket " + scan + " has been used " + ct + " times."));
				ct = 0; // Reset count
			}
	}

	/* Event handler for onCancel and will show the init event gui */
	function onQuit() {
		gui.showDialog(eventDemo);
	}

	/* Event handler for onOptionCancel and will show the available event options */
	function onOptionCancel() {
		gui.showDialog(eventDemo.options);
	}

	/* Gui to handle exiting event demo */
	function onEventCancel() 
	{
		cancelYesNo                = new gui.Menu     (                   );
		cancelYesNo.caption = "Exit Event App?";
		cancelYesNo.leftSoftkey        = new gui.Softkey  ("Yes", function() {menu = demoOptions;gui.showDialog(menu);});
		cancelYesNo.rightSoftkey       = new gui.Softkey  ("No",  function() {gui.showDialog(eventDemo);});
		menu = cancelYesNo;
		gui.showDialog(menu);
			
	};

	/* Handle ondecode data */
	reader.onDecode = function(decode)
	{
		if ( demo_Event ) {
			if (decode != null )
			{
				if (!checkScan )
				{
					readData(decode);				
				}
				else
				{
					ticketCheck(decode);
					
				}
			}
			else 
			{
				gui.show(new gui.Text("Invalid ticket"));
			}
		}	
	}


	/* Main code for storage of scanned data */
	function readData(data) {
		
		eventNum = "";
		eventNum = data.data;
		var isValid = isDups(eventNum);
		var isCode = isBarcode(eventNum);
		
		if (isCode) 
		{
			// check to see if ticketnum is a duplicate
			if (!isValid) {
				var setDate = getCurrentTime();
				var setName = eventNum + "_" + setDate + "_" + eventName;
				arrayList[arrayList.length] = setName;	
				updateTicketTotal();
				//reader.beep(1);
				//reader.setDisplayLed(reader.green);
				gui.show(new gui.Text(eventNum + '\n' + "Time: " + setDate));	

			}	
			else
			{
				reader.beep(2);
				//reader.setDisplayLed(reader.red);
				gui.show(new gui.Text("Duplicate ticket"));
				updateArrayList(eventNum);

			}
		}
	}

	/* Check the format of the barcode to ensure it's in the correct format for scanning. */
	function isBarcode(code)
	{
		var isValid = false;
		// Check length of barcode
		if (eventNum.length == 19 ) 
		{
			
			// Check ticket number (first 5 digits..Rquirements changed...not used)
			/*for (var i = 0; i < 5; i++)
			{
				if (parseInt(eventNum[i]) == "NaN")
				{
					gui.show(new gui.Text("Barcode number not valid."));
					isValid = false;
					return isValid;
				}
				
			}
			
			for (var c = 11; c < eventNum.length; c++)
			{
				if (parseInt(eventNum[c] == "NaN"))
				{
					gui.show(new gui.Text("Barcode date not valid."));
					isValid = false;
					return isValid;
				}
			}
			*/
			isValid = true;
			return isValid;
					
		}
		else
		{
			reader.beep(4);
			gui.show(new gui.Text("Ticket not valid.  Please try again."));
			isValid = false;
			return isValid;
		}	
	}

	/* Format the current date *** not used unless to we want to show the particular format of the date representation */
	function dateFormat(cDate)
	{
		var month = cDate.substr(0,2);
		var day = cDate.substr(2,2);
		var year = cDate.substr(4,4);
		switch (month)
		{
			
			case "1":
				month = "Jan";
				break;
			case "2":
				month = "Feb";
				break;
			case "3":
				month = "Mar";
				break;
			case "4":
				month = "Apr";
				break;
			case "5":
				month = "May";
				break;
			case "6":
				month = "Jun";
				break;
			case "7":
				month = "Jul";
				break;
			case "8":
				month = "Aug";
				break;
			case "9":
				month = "Sep";
				break;
			case "10":
				month = "Oct";
				break;
			case "11":
				month = "Nov";
				break;
			case "12":
				month = "Dec";
				break;			
		}

		var dDate = month + " " + cDate.substr(2,2) + ", " + cDate.substr(4,4);
		var time = [3];
		time[0] = cDate.substr(9,2);
		time[1] = cDate.substr(12,2);
		time[2] = cDate.substr(15,2);
		for (var i = 0; i < time.length; i++)
		{
			if (time[i].length == 1)
			{
				time[i] = "0" + time[i];
			}
		}
		
		dDate = dDate + " " + time[0] + ":" + time[1] + ":" + time[2];
		return dDate;
	}

	/* Updates the current ticket count */
	function updateTicketTotal()
	{
		totalTickets++;
	}

	/* Updates the arraylist and event totals */
	function updateArrayList(dupTicket)
	{
		arrayList[arrayList.length] = dupTicket + "_" +getCurrentTime() + "_" + eventName;	
		updateTicketTotal();
	}

	/* Returns the current ticket number */
	function getCurTicket(data)
	{
		
		return data.substring(0,5); // grab the first 5 characters for numbers
		
		
	}

	/* Returns the hourly totals of the tradeshow */
	function getHourlyTotal() {
		
		var currHr = getCurrentTime();
		var index = currHr.indexOf(":");
		var currHr = currHr.substring(index-2, index);
		var hourlyTotal = 0;
		
		for (var i = 0; i < arrayList.length; i++) 
		{
			var id = arrayList[i].substring(arrayList[i].indexOf(":") - 2, arrayList[i].indexOf(":"));
			if (id.match(currHr))
				hourlyTotal++;
		}
		
		return hourlyTotal;
		
	}

	/* Returns the number of times the ticket has been scanned */
	function getReentryCount(ticketNumber) {
		
		var t = 0;
		var count = 0;
		while (t < arrayList.length)
		{
			var num = arrayList[t].indexOf(ticketNumber);
			if (num != -1)
			{
				count++;
			}
			if (count == 0 )
			{
				reader.beep(4);
				//reader.setDisplayLed(reader.red);
				gui.show(new gui.Text("Invalid Ticket"));
			}
		}
		return count;	
	}

	/* Returns the current date and time */
	function getCurrentTime()
	{
		var currentDate = Date(); // format=10112013_16:24:32
		return currentDate.substring(4,24);
	};
		
	/* Returns boolean once it checks for the rescan */
	function isDups(data)
	{
		var dupe = false;
		var i = 0;
		
		while ( i < arrayList.length )
		{		
			var arrayStr = arrayList[i].indexOf("_");
			var dupeStr = arrayList[i].toString().substring(0,arrayStr);
			if ( dupeStr == data ) {			
				dupe = true;
				break;
			}
			i++;			
		}
		
		return dupe;
		
	};

	/* Get the total number of valid ticket (including re-entry tickets) */
	function getEventTotal()
	{
		
		return arrayList.length;
	 
	};