	/* Filename:    .dOptions.js
	 * Description: This application demonstrate the capability of the CS3600 in an event settings such as concerts, clubs, etc.
	 *              When the system boots, the user will be able to enter demo mode to test functionalities that are capabile
	 *              with the 3600 system.
	 * Copyright:   2013 The Code Corporation. All rights are reserved.
	 * $Title: dOptions $
	 * $Revision: 1.0 $
	 * $Date: 2013-10-21 09:34:52 $
	 * $Author: Dthai 
	 */
 
	include(".cre.js");
	
	//Override ready.show 
	ready.oldShow = ready.show;
	ready.show = function(text, busy)
	{
		//Do nothing for demo script
	}
	
	/* Data variables for demo options */

	var isDemo = false;
	var isInventory = false;
	var isEvents = false;
	var isTradeshow = false;
	var demoOptions = "";

	/* Create the initial splash screen */
	var demoOptions = new gui.Menu;
	demoOptions.caption = "CR3600 Apps";
	demoOptions.leftSoftkey = new gui.Softkey ("Select", function() {gui.sendKey(gui.key.enter);});
	demoOptions.rightSoftkey = new gui.Softkey ("Exit", demoQuit);
	demoOptions.append(new gui.MenuItem("Admissions", loadAdmissions));
	demoOptions.append(new gui.MenuItem("ID Verification", loadVerification));
	demoOptions.append(new gui.MenuItem("Inventory", loadInventory));
	gui.showDialog(demoOptions);

	/* Quit the demo */
	function demoQuit()
	{
		 var demoExit = new gui.Menu;
		 demoExit.caption = "Exit Apps?";
		 demoExit.leftSoftkey = new gui.Softkey ("Yes", onDemoCancel);
		 demoExit.rightSoftkey = new gui.Softkey ("No", function() { menu = demoOptions; gui.showDialog(menu);});
		 gui.showDialog(demoExit);
	}

	/* Exits the demo splash screen and returns to the barcodes default js file */
	function onDemoCancel() {
		reader.processCommand("C", "(" + setting_useDemoScript.toString(16) + ")0");
		reader.runScript(".default.js");
	}

	/* Load ID Verification demo */
	function loadVerification()
	{
		reader.runScript(".dVerification.js");
	}

	/* Load inventory demo */
	function loadInventory() {
		reader.runScript(".dInventory.js");			
	}

	/* Load Admissions demo */
	function loadAdmissions()
	{
		 var admissionsOptions = new gui.Menu;
		 admissionsOptions.caption = "Select type";
		 admissionsOptions.leftSoftkey = new gui.Softkey ("Select", function() {gui.sendKey(gui.key.enter);});
		 admissionsOptions.rightSoftkey = new gui.Softkey ("Exit", function() { gui.showDialog(demoOptions)});
		 admissionsOptions.append(new gui.MenuItem("Events", loadEvent));
		 admissionsOptions.append(new gui.MenuItem("Tradeshow", loadTradeshow));
		 gui.showDialog(admissionsOptions);
	}

	/* Load events demo */
	function loadEvent() {
		reader.runScript(".dEvents.js");			
	}

	/* Load tradeshow demo */
	function loadTradeshow() {
		reader.runScript(".dTradeshow.js");
	}


