	/* Filename:    .dTradeshow.js
	 * Description: This application demonstrate the capability of the CS3600 in an tradeshow events.
	 * Copyright:   2013 The Code Corporation. All rights are reserved.
	 * $Title: dTradeshow $
	 * $Revision: 1.0 $
	 * $Date: 2013-10-08 09:14:02 $
	 * $Author: Dthai
	 */
	 
	include (".dOptions.js");
	include(".cre.js");
	
	//Override ready.show 
	ready.oldShow = ready.show;
	ready.show = function(text, busy)
	{
		//Do nothing for demo script
	}

	/* Data variables for tradeshow */
	var badgeNum = "";
	var tradeshow_Event = true;
	var eventName = "tradeshow";
	var totalTickets = 0;
	var hourlyTotal = 0;
	var isCheckScan = false;
	var menu = "";
	var enabledScan = true;
	var bAttendee = true;
	var bExhibitor = false;
	var arrayList = [];
	var companyList = [];
	var companyListCnt = [];
	var badgeList = [];
	var type = ""; //getScanType(badgeNum);
	var badge = "";
	var firstName = "";
	var lastName = "";
	var position = "";
	var company = "";
	var city = "";
	var state = "";
	var phone = "";
	var email = "";  // to be added to barcode
 
	/* Show the default tradeshow at startup */
	tradeshowDemo = new gui.Menu     ();
	tradeshowDemo.leftSoftkey             = new gui.Softkey  ("Options",    function() {menu = tradeshowDemo.options; gui.showDialog(menu);});
	tradeshowDemo.rightSoftkey            = new gui.Softkey  ("Exit", onTradeshowCancel);

	tradeshowDemo.append                   (new gui.Label    (" "               ));
	tradeshowDemo.append                   (new gui.Label    ("      CR3600   "  ));
	tradeshowDemo.append                   (new gui.Label    ("   Tradeshow  "  ));
	tradeshowDemo.append                   (new gui.Label    ("       Demo    "  ));
	tradeshowDemo.append                   (new gui.Label    (" "               ));

	tradeshowDemo.options = new gui.Menu;
	tradeshowDemo.options.caption = "Show options";
	tradeshowDemo.options.leftSoftkey	   = new gui.Softkey  ("Select",  function() {gui.sendKey(gui.key.enter);});
	tradeshowDemo.options.rightSoftkey	   = new gui.Softkey  ("Back",  onQuit);
	tradeshowDemo.options.append(new gui.MenuItem("Scan Ready", startScan ) );
	tradeshowDemo.options.append(new gui.MenuItem("Hourly Totals", showHourlyTotals ) );
	tradeshowDemo.options.append(new gui.MenuItem("Daily Totals", showEventTotals ) );
	tradeshowDemo.options.append(new gui.MenuItem("Check badge", checkTicket ));
	tradeshowDemo.options.append(new gui.MenuItem("List attendees", listAttendees));
	tradeshowDemo.options.append(new gui.MenuItem("Send/Log", fileSave ) );
		
	menu = tradeshowDemo;
	gui.showDialog(menu);	

	/* Show the initial dialog for tradeshow demo */
	function startScan()
	{
		
		start                = new gui.Menu     (                   );
		start.caption = "Scan badge";
		start.rightSoftkey       = new gui.Softkey  ("Back",  onOptionCancel);
		menu = start;
		gui.showDialog(menu);
		
	}; 

	/* Autosave the data to file in case reader freezes or other problems arises */
	function autoSave ( data )
	{
		var file = "tradeshow_log.demo";
		storage.append (file, data + '\r\n');
	}

	/* Data will be resaved that are on the array list */
	function fileSave()
	{
		fileIt                = new gui.Menu     (                   );
		fileIt.caption = "Saving to file?";
		fileIt.leftSoftkey        = new gui.Softkey  ("Save", onSave);
		fileIt.rightSoftkey       = new gui.Softkey  ("Cancel",  onCancel);

		menu = fileIt;
		gui.showDialog(menu);
		
	}

	/* Functionality to save the data to file */
	function onSave()
	{	
		var file = "tradeshow_log.demo";
		
		if (arrayList.length != 0 )
		{
			for (var i = 0; i < arrayList.length; i++)
			{			
				storage.append (file, arrayList[i].toString() + '\r\n');
			}
		}
		else 
		{
			reader.beep(4);
			//reader.setDisplayLed(reader.red);
			gui.show(new gui.Text("Error, no data found"));
		}
		menu = tradeshowDemo.options;
		gui.show(new gui.Text("Saved!"));
		gui.showDialog(menu);
	}

	/* Gui to show the total hourly attendees */
	function showHourlyTotals()
	{	
		hrTotal = new gui.Menu();
		hrTotal.caption = "Hourly totals";
		//hrTotal.leftSoftkey       = new gui.Softkey  (" ",  onOptionCancel);
		hrTotal.rightSoftkey       = new gui.Softkey  ("Back",  onOptionCancel);	
		menu = hrTotal;
		gui.showDialog(menu);
		var hrTotals = getHourlyTotal();
		gui.show(new gui.Text("Current Hr total: " + hrTotals));	
	}

	/* Gui to show the total number of attendees */
	function showEventTotals() 
	{
		showTotal = new gui.Menu();
		showTotal.caption = "Show totals";
		//showTotal.leftSoftkey       = new gui.Softkey  ("", onOptionCancel);	
		showTotal.rightSoftkey       = new gui.Softkey  ("Back",  onOptionCancel);	
		menu = showTotal;
		gui.showDialog(menu);
		var showTotalCnt = getEventTotal();
		gui.show(new gui.Text("Show totals: " + showTotalCnt));
			
	}

	/* Check ticket menu */
	function checkTicket()
	{
		
		checkIt = new gui.Menu();
		checkIt.caption = "Check badge";
		checkIt.rightSoftkey       = new gui.Softkey  ("Back",  function() {isCheckScan = false; onOptionCancel();});
		isCheckScan = true;
		menu = checkIt;
		gui.showDialog(menu);
		
	}

	/* Check attendee count for specific company */
	function listAttendees()
	{
		var companyMenu = new gui.Menu();
		companyMenu.caption = "Attendee Count";
		companyMenu.rightSoftkey       = new gui.Softkey  ("Back",  function() {onOptionCancel();});
		
		for (var i = 0; i < companyList.length; i++)
		{
			companyMenu.append(new gui.MenuItem(companyList[i].substring(0, 11) + "  " + companyListCnt[i] ));
		}

		menu = companyMenu;
		gui.showDialog(menu);
		
	}

	/* Event handler for onOptionCancel and will show the available tradeshow options */
	function onOptionCancel() {

		gui.showDialog(tradeshowDemo.options);

	}


	/* Check to see if a ticket has been scan and for how many times used. */
	function ticketCheck(data)
	{	
		// process data
		var scan = data.data;
		var ct = 0;
		for (var i = 0; i < arrayList.length; i++)
		{
			var arrayStr1 = arrayList[i].indexOf("*");
			var arrayStr2 = arrayList[i].indexOf("_");
			if (scan == arrayList[i].toString().substring(arrayStr1 + 1,arrayStr2))
			{
				ct++;
			}				
		}
		
		if ( ct == 0 )
		{
			reader.beep(4);
			//reader.setDisplayLed(reader.red);
			gui.show(new gui.Text("There are no entry for this badge."));

		}
		else
		{
			reader.beep(1);
			//reader.setDisplayLed(reader.green);
			gui.show(new gui.Text("Badge " + scan + " has been used " + ct + " times."));
			ct = 0; // Reset count
		}
	}

	/* Returns the Nth occurrence of a string value */
	function getNthOccurrence(str, value, iterator)
	{	
		var pos = str.indexOf(value, 0);
		var cnt = 0;
		while( parseInt(iterator) > 0 && pos != -1 )
		{
			pos = str.indexOf( value, pos + 1 );
			// Data is in the 5th iteration of the string
			if (cnt == parseInt(iterator) )
				break;
			cnt++;
		}
		return pos;
	}

	/* Process the number of times a company is represented at the tradeshow.  Use as a tool to rate leads. */
	function updateCompanyList(badge, company)
	{
		if (companyList.indexOf(company) == -1)
		{
			companyList[companyList.length] = company;
			companyListCnt[companyListCnt.length] = 1;		
			badgeList[badgeList.length] = badge;
		}
		else
		{				
			if (badgeList.indexOf(badge) == -1 )
			{
				companyListCnt[companyList.indexOf(company)] = companyListCnt[companyList.indexOf(company)] + 1;
				badgeList[badgeList.length] = badge;
			}
		}
	}

	/* Event handler for onCancel and will show the init tradeshow gui */
	function onQuit() {
		gui.showDialog(tradeshowDemo);
	}

	/* Gui to handle exiting tradeshow demo */
	function onTradeshowCancel() 
	{
		cancelYesNo                = new gui.Menu     (                   );
		cancelYesNo.caption = "Exit Tradeshow?";
		cancelYesNo.leftSoftkey        = new gui.Softkey  ("Yes", function() {menu = demoOptions;gui.showDialog(menu);});
		cancelYesNo.rightSoftkey       = new gui.Softkey  ("No",  function() {gui.showDialog(tradeshowDemo);});
		menu = cancelYesNo;
		gui.showDialog(menu);
			
	}

	/* Handle ondecode data */
	reader.onDecode = function(decode)
	{
		
		if ( tradeshow_Event ) 
		{
			if (decode != null )
			{
				reader.setDisplayLed(reader.none);
				if (!isCheckScan)
				{

					readData(decode);
				}
				else
				{
					ticketCheck(decode);
				}
			}
			else 
			{
				gui.show(new gui.Text("Invalid ticket"));
			}
		}	
	}

	/* Returns either an exhibitor or attendee flag */
	function getScanType(ticket)
	{
		var typeChar = "";
		if ( ticket.substring(0,1) == 'A') 
			typeChar = "Attendee";
		else
			typeChar = "Exhibitor";
		
		return typeChar;
	}

	/* Main code for storage of scanned data */
	function readData(data) {
		
		badgeNum = "";
		badgeNum = data.data;
		var isValid = isDups(badgeNum);
		var isCode = isBarcode(badgeNum);
		
		if (isCode) 
		{	
			// check to see if badgeNum is a duplicate
			if (!isValid) 
			{
				var setDate = getCurrentTime();// Need to ensure we get the current timestamp			
				var setName = badgeParsing() + "_" + setDate + "_" + eventName;
				arrayList[arrayList.length] = setName;	
				updateTicketTotal();
				//reader.setDisplayLed(reader.green);
				autoSave(setName);
				gui.show(new gui.Text(showBadgeData() + '\n' + "Time: " + setDate));	

			}
			else 
			{
				reader.beep(2);
				reader.setDisplayLed(reader.red);
				gui.show(new gui.Text("Duplicate"));
				updateArrayList(badgeNum);
			}
		}			
	}

	/* Check the format of the barcode to ensure it's in the correct format for scanning. */
	function isBarcode(code)
	{
		// Check length of barcode
		if ((badgeNum.split("*").length - 1) == 9 ) 
		{
			// Check 1st 5 characters for digit (Rquirements changed...not used)
			// *** Not needed now but Check ticket number (first 5 digits)
			/*for (var i = 0; i < 5; i++)
			{
				if (parseInt(eventNum[i]) == "NaN")
				{
					gui.show(new gui.Text("Barcode number not valid."));
					isValid = false;
					return isValid;
				}
				
			}
			
			// Check middle segment for event name (Rquirements changed...not used)
			for (var c = 11; c < eventNum.length; c++)
			{
				if (parseInt(eventNum[c] == "NaN"))
				{
					gui.show(new gui.Text("Barcode date not valid."));
					isValid = false;
					return isValid;
				}
			}
			*/
			return true;
					
		}
		else
		{
			reader.beep(4);
			gui.show(new gui.Text("Barcode not valid.  Please try again."));
			return false;
		}
	}

	/* Show data layout on the gui dialog once scanned */
	function showBadgeData()
	{
		var badgeDataString =  type + '\n' +
					badge + '\n' +
						firstName + " " + lastName + '\n' +
					position + '\n' +
					company + '\n' +
					city + ", " + state + '\n' +
					phone + '\n' +
					email + '\n';
					
		return badgeDataString;	
	}

	/* Parse ondecode data */
	function badgeParsing()
	{
		var ct = 0;
		var pos = "";
		var prevPos = "";
		
		while (pos != -1)
		{	
			pos = badgeNum.indexOf("*", pos + 1);
			switch (ct)
			{
				case 0: 
					badge = badgeNum.substr( ct, pos);
					type = getScanType(badge);				
					break;
				case 1: 
					firstName = badgeNum.substr( prevPos, pos - prevPos );	
					break;
				case 2: 
					lastName = badgeNum.substr( prevPos, pos - prevPos);	
					break;
				case 3: 
					position = badgeNum.substr( prevPos, pos - prevPos);	
					break;
				case 4: 
					company = badgeNum.substr( prevPos, pos - prevPos);	
					break;
				case 5: 
					city = badgeNum.substr( prevPos, pos - prevPos);	
					break;
				case 6: 
					state = badgeNum.substr( prevPos , pos - prevPos);	
					break;				
				case 7:
					phone = badgeNum.substr( prevPos, pos - prevPos);	
					break;
				case 8:
					email = badgeNum.substr( prevPos, pos - prevPos);	
					break;
			}
			prevPos = pos + 1;
			ct++;
		}
		updateCompanyList(badge, company);// Record tally for each company
		
		return type + "*" + badge + "*" + firstName + "*" + lastName + "*" +position + "*" + company + "*" + city + "*" + state + "*" + phone + "*" + email + "*";
	}

	/* Format the current date *** not used unless to we want to show the particular format of the date representation */
	function dateFormat(cDate)
	{
		var month = cDate.substr(0,2);
		var day = cDate.substr(2,2);
		var year = cDate.substr(4,4);
		switch (month)
		{
			
			case "1":
				month = "Jan";
				break;
			case "2":
				month = "Feb";
				break;
			case "3":
				month = "Mar";
				break;
			case "4":
				month = "Apr";
				break;
			case "5":
				month = "May";
				break;
			case "6":
				month = "Jun";
				break;
			case "7":
				month = "Jul";
				break;
			case "8":
				month = "Aug";
				break;
			case "9":
				month = "Sep";
				break;
			case "10":
				month = "Oct";
				break;
			case "11":
				month = "Nov";
				break;
			case "12":
				month = "Dec";
				break;			
		}

		var dDate = month + " " + cDate.substr(2,2) + ", " + cDate.substr(4,4);
		var time = [3];
		time[0] = cDate.substr(9,2);
		time[1] = cDate.substr(12,2);
		time[2] = cDate.substr(15,2);
		for (var i = 0; i < time.length; i++)
		{
			if (time[i].length == 1)
			{
				time[i] = "0" + time[i];
			}
		}
		
		dDate = dDate + " " + time[0] + ":" + time[1] + ":" + time[2];
		return dDate;
	}

	/* Updates the current ticket count */
	function updateTicketTotal()
	{
		totalTickets++;
	}

	/* Updates the arraylist and event totals */
	function updateArrayList(dupTicket)
	{
		arrayList[arrayList.length] = badgeParsing() + "_" +getCurrentTime() + "_" + eventName;	
		autoSave (badgeParsing() + "_" +getCurrentTime() + "_" + eventName);
		updateTicketTotal();
	}

	/* Returns the current badge number */
	function getCurTicket(data)
	{
		
		return data.substring(0,6); // grab the first 6 characters for numbers
		
	}

	/* Returns the hourly totals of the tradeshow */
	function getHourlyTotal() {
		
		var currHr = getCurrentTime();
		var index = currHr.indexOf(":");
		var currHr = currHr.substring(index-2, index);
		var hourlyTotal = 0;
		
		for (var i = 0; i < arrayList.length; i++) 
		{
			var id = arrayList[i].substring(arrayList[i].indexOf(":") - 2, arrayList[i].indexOf(":"));
			if (id == currHr)
				hourlyTotal++;
		}
			
		return hourlyTotal;	
	}
	 
	/* Returns the number of times the ticket has been scanned */
	function getReentryCount(ticketNumber) {
		
		var t = 0;
		var count = 0;
		while (t < arrayList.length)
		{
			var num = arrayList[t].indexOf(ticketNumber);
			if (num != -1)
			{
				count++;
			}
			if (count == 0 )
			{
				reader.beep(4);
				//reader.setDisplayLed(reader.red);
				gui.show(new gui.Text("Invalid Number"));
			}
		}
		return count;	
	}

	/* Returns the current date and time */
	function getCurrentTime()
	{

		var currentDate = Date(); // format=10112013_16:24:32	
		
		return currentDate.substring(4,24);
	}
		
	/* Returns boolean once it checks for the rescan */
	function isDups(data)
	{
		var dupe = false;
		var i = 0;
		while ( i < arrayList.length )
		{		
			var arrayStr1 = arrayList[i].indexOf("*");
			var arrayStr2 = arrayList[i].indexOf("_");
			var dupeStr = arrayList[i].toString().substring(arrayStr1 + 1,arrayStr2);
			if ( dupeStr == data ) {			
				dupe = true;
				break;
			}
			i++;			
		}
		return dupe;
	};

	/* Get the total number of valid ticket (including re-entry tickets) */
	function getEventTotal()
	{
		
		return arrayList.length;
	 
	};