	/* Filename:    .dVerification.js
	 * Description: This application demonstrate the capability of the CS3600 with ID or Age Verification.
	 *              
	 * Copyright:   2013 The Code Corporation. All rights are reserved.
	 * $Title: dVerification $
	 * $Revision: 1.0 $
	 * $Date: 2013-11-12 02:35:52 $
	 * $Author: Dthai 
	 */
	
	include(".dOptions.js");
	include(".cre.js");
	
	//Override ready.show 
	ready.oldShow = ready.show;
	ready.show = function(text, busy)
	{
		//Do nothing for demo script
	}

	/* Data variables for checking for Driver License
		- Card ID #
		- last name
		- first name, middle name
		- date of birth
		- Height
		- Weight
		- Hair color
		- Eye color
		- Address
		- city
		- State
		- Zip code
		- Country
		
		Data to general age verification
		- Date of birth
		- last name
		- First name, middle name
		- over/under 21 or invalid
	 */
  
	 var isDemo = false;
	 var idOptions = "";
	 var isAgeVerify = true;
	 var is21 = false;
	 var idNum = ""
	 var lastName = "";
	 var firstName = "";
	 var fullName = "";
	 var dob = "";
	 var age = "";
	 var height = "";
	 var weight = "";
	 var eyeColor = "";
	 var hairColor = "";
	 var address = "";
	 var city = "";
	 var state = "";
	 var zip = "";
	
	 /* Create the initial splash screen */
	 var idOptions = new gui.Menu;
	 idOptions.caption = "Verification";
	 idOptions.leftSoftkey = new gui.Softkey ("Select", function() {gui.sendKey(gui.key.enter);});
	 idOptions.rightSoftkey = new gui.Softkey ("Exit", idQuit);
	 idOptions.append(new gui.MenuItem("Age", ageScan));
	 idOptions.append(new gui.MenuItem("ID", idScan));
	 gui.showDialog(idOptions);

	 /* Handle ondecode data */
	 reader.onDecode = function(decode)
	 {
		if (decode != null )
		{		
			readData(decode);						
		}
		else 
		{
			gui.show(new gui.Text("Invalid ticket"));
		}
	 }
	 
	 /* Main code for storage of scanned data */
	 function readData(data) {
		
		idNum = data.data;
		if (data.symbology == 38 && data.data.match(/^@/))
		{
				var setDate = getCurrentTime();
				// Parse data
				parseData();
				// Check if Age Verification
				if ( isAgeVerify )
				{	
					if (dob.length > 8)
					{
						while (dob.indexOf("-") != -1 ) 
						{
							dob = dob.replace("-", '');
						}					
					}
					
					if (dob.substring(0,2) == 19 || dob.substring(0,2) == 20 ) // check dob format yyyymmdd
					{
						var month = dob.substring(4,6), day = dob.substring(6,8), year = dob.substring(0,4);
					}
					else // dob format mmddyyyy
					{
						var month = dob.substring(0,2) - 1, day = dob.substring(2,4), year = dob.substring(4,8);
					}
					
					var dateObj = new Date(year,month,day);
					age = getAge(dateObj);
					if ( age < 21 ) {
						gui.show(new gui.Text("Under 21" + '\n\n' + fullName));
					}
					else 
					{
						gui.show(new gui.Text("Over 21" + '\n\n' + fullName));
					}
					
				}
				else
				{
					gui.show(new gui.Text(showIdData() + '\n\n' + "Time: " + setDate));	
				}
		}
		else
		{
			reader.beep(3);
			gui.show(new gui.Text("Barcode not valid.  Please try again."));		
		}
	 }
 
	 /* Parse the DL data and grab the correct element ID */
	 function parseData()
	 {	
		 var tempName = "";
		 var lastNameIdx = "";
		 var firstNameIdx = "";
		 
		 // Check first and lastname
		 if (idNum.indexOf("DCS") != -1 )
		 {
			 lastNameIdx = idNum.indexOf("DCS");
			 tempName = idNum.substr(lastNameIdx, idNum.length);
			 lastName = tempName.substr(3, tempName.indexOf('\n') -3);
			 firstNameIdx = idNum.indexOf("DCT");
			 tempName = idNum.substr(firstNameIdx, idNum.length);
			 firstName = tempName.substr( 3, tempName.indexOf('\n') -3 );
			 fullName = lastName + " " + firstName;
		 }
		 else
		 {
			 
			 if (idNum.indexOf("DAA") != -1 )
			 {
				 lastNameIdx = idNum.indexOf("DAA");
				 tempName = idNum.substr(lastNameIdx, idNum  .length);
				 fullName = tempName.substr( 3, tempName.indexOf('\n') - 3);
			 }
			 else
			 {	 
				 if (idNum.indexOf("DAB") != -1 )
				 {
					 lastNameIdx = idNum.indexOf("DAB");
					 tempName = idNum.substr(lastNameIdx, idNum.length);
					 lastName = tempName.substr(3, tempName.indexOf('\n') - 3);
					 firstNameIdx = idNum.indexOf("DAC");
					 tempName = idNum.substr(firstNameIdx, idNum.length);
					 firstName = tempName.substr( 3, tempName.indexOf('\n') - 3 );
					 fullName = lastName + " " + firstName;
				 }
				 else
				 {
					 fullName = "No name";
				 }
			 }
		 }
		 
		 //DOB
		 if ( idNum.indexOf("DBB") != -1) {
			var tempDOB = idNum.indexOf("DBB");
			tempName = idNum.substr(tempDOB, idNum.length);
			dob = tempName.substr( 3, tempName.indexOf('\n') - 3 );		
		 }
		 
		 //Sex
		 if ( idNum.indexOf("DBC") != -1) {
			var tempMF = idNum.indexOf("DBC");
			tempName = idNum.substr(tempMF, idNum.length);
			sex = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 
		 //height 
		 if ( idNum.indexOf("DAU") != -1) {
			var tempHT = idNum.indexOf("DAU");
			tempName = idNum.substr(tempHT, idNum.length);
			height = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 
		 // weight
		 if ( idNum.indexOf("DAW") != -1) {
			var tempWT = idNum.indexOf("DAW");
			tempName = idNum.substr(tempWT, idNum.length);
			weight = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 else
		 {
			 weight = "N/A";
		 }
		 
		 // eye Color
		 if ( idNum.indexOf("DAY") != -1) {
			var tempEye = idNum.indexOf("DAY");
			tempName = idNum.substr(tempEye, idNum.length);
			eyeColor = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 else
		 {
			 eyeColor = "N/A";
		 }
		 
		 // hair color
		 if ( idNum.indexOf("DAZ") != -1) {
			var tempHair = idNum.indexOf("DAZ");
			tempName = idNum.substr(tempHair, idNum.length);
			hairColor = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 else
		 {
			 hairColor = "N/A";
		 }
		 
		 // address
		 var tempAddr = "";
		 if ( idNum.indexOf("DAG") != -1) {
			tempAddr = idNum.indexOf("DAG");
			tempName = idNum.substr(tempAddr, idNum.length);
			address = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 else
		 {
			 if (idNum.indexOf("DAL") != -1 ) {
				tempAddr = idNum.indexOf("DAL");
				tempName = idNum.substr(tempAddr, idNum.length);
				address = tempName.substr( 3, tempName.indexOf('\n') - 3 );
			 }
			 else
				address = "N/A";
		 }
		 
		 // city
		 var tempCity = "";
		 if ( idNum.indexOf("DAI") != -1) 
		 {
			tempCity = idNum.indexOf("DAI");
			tempName = idNum.substr(tempCity, idNum.length);
			city = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 else
		 {
			 if (idNum.indexOf("DAN") != -1 ) {
				tempCity = idNum.indexOf("DAN");
				tempName = idNum.substr(tempCity, idNum.length);
				city = tempName.substr( 3, tempName.indexOf('\n') - 3 );
			 }
			 else
				city = "N/A";
		 }
		 
		 // state
		 var tempState = "";
		 if ( idNum.indexOf("DAJ") != -1) 
		 {
			tempState = idNum.indexOf("DAJ");
			tempName = idNum.substr(tempState, idNum.length);
			state = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 else
		 {
			 if (idNum.indexOf("DAO") != -1 ) {
				tempState = idNum.indexOf("DAO");
				tempName = idNum.substr(tempState, idNum.length);
				state = tempName.substr( 3, tempName.indexOf('\n') - 3 );
			 }
			 else
				state = "N/A";
		 }
		 
		 // zip
		 var tempZip = "";
		 if ( idNum.indexOf("DAK") != -1) 
		 {
			tempZip = idNum.indexOf("DAK");
			tempName = idNum.substr(tempZip, idNum.length);
			zip = tempName.substr( 3, tempName.indexOf('\n') - 3 );
		 }
		 else
		 {
			 if (idNum.indexOf("DAP") != -1 ) {
				tempZip = idNum.indexOf("DAP");
				tempName = idNum.substr(tempZip, idNum.length);
				zip = tempName.substr( 3, tempName.indexOf('\n') - 3 );
			 }
			 else
				zip = "N/A";
		 }
		 
	 }
 
	 /* Show data layout on the gui dialog once scanned */
	 function showIdData()
	 {
		var idDataString =  fullName + '\n' + 						
							"DOB: " + dob + '\n' +
							"Sex: " + sex + '\n' + 
							"Ht: " + height + ", Wt: " + weight + '\n' +
							"Eye color: " + eyeColor + '\n' +
							"Hair color: " + hairColor + '\n' +
							address + '\n' + 
							city + ", " + state + '\n' +
							zip;
											
		return idDataString;	
	 }
	 
	 /* Returns the current date and time */
	 function getCurrentTime()
	 {
		var currentDate = Date(); // format=10112013_16:24:32	
		
		return currentDate.substring(4,24);
	 }
	 
	 /* Show the initial dialog for events demo */
	 function ageScan()
	 {
		start         = new gui.Menu();
		start.caption = "Verify Age";
		start.rightSoftkey       = new gui.Softkey  ("Back",  function() { gui.showDialog(idOptions);});
		menu = start;
		isAgeVerify = true;
		gui.showDialog(menu);
	 }

	 /* Show the initial dialog for events demo */
	 function idScan()
	 {
		start         = new gui.Menu();
		start.caption = "Verify ID";
		start.rightSoftkey       = new gui.Softkey  ("Back",  function() { gui.showDialog(idOptions);});
		menu = start;
		isAgeVerify = false;
		gui.showDialog(menu);
	 }
	 
	 /* Quit the demo */
	 function idQuit()
	 {
		 var idExit = new gui.Menu;
		 idExit.caption = "Exit Verification?";
		 idExit.leftSoftkey = new gui.Softkey ("Yes", function() {menu = demoOptions;gui.showDialog(menu);});
		 idExit.rightSoftkey = new gui.Softkey ("No", function() {gui.showDialog(idOptions);});
		 gui.showDialog(idExit);
	 }
 
	  /* Calculate the age */
	  function getAge(birthDate) 
	  {
		
		var currentDate = new Date();
		var currentMonth = currentDate.getMonth();
		var currentDay = currentDate.getDate();
		var currentYear = currentDate.getFullYear();
		var now = new Date(currentYear, currentMonth, currentDay-1);

		function isLeap(year) 
		{
			return year % 4 == 0 && (year % 100 != 0 || year % 400 == 0); // leap year?
		}

		// number of days from the  birthdate date 
		var numDays = Math.floor((now.getTime() - birthDate.getTime())/1000/60/60/24); //msec/sec/min/hr = day
		numDays = numDays -1;
		var theAge = 0;
		// Parse the years to determine to determine leap year
		for (var i = birthDate.getFullYear(); i <= currentDate.getFullYear(); i++)
		{
			var numDaysInEachYear = isLeap(i) ? 366 : 365; // if true 366 else 365 days
			if (numDays >= numDaysInEachYear)
			{			
			  numDays -= numDaysInEachYear;
			  theAge++;		  
			}
		}
		return theAge;
	  }

