/* .settings.js
 * provides constants for useful CR2/CR3 standard settings
 *
 * $Revision: 7022 $
 *
 * Copyright 2006 The Code Corporation. All rights are reserved.
 */


//Settings
setting_backlightTimeout_ms       = 0x100;
setting_commMode                  = 0x01b;
commMode_bt                       = 4;
commMode_btKb                     = 10;

setting_button1_event             = 0x039;
setting_button2_event             = 0x03a;
setting_button4_event             = 0x03c;
setting_appleMode_event           = 0x025f;

setting_prefixWithTimestamp       = 0x046;
setting_autoLogErase              = 0x072;

setting_sendStoreMode             = 0x076;
alwaysStoreBit                    = 0x001;
noAutoSendBit                     = 0x002;

setting_autoBufferUpload          = 0x073;

setting_autoConnectPeriod_ms      = 0x08d;

setting_autoConnectMode           = 0x0c6;
noAutoConnect                     =     0;
autoConnect                       =     1;
autoReconnect                     =     2;
autoConnectIfCabledOrNeedToSend   =     3;

setting_autoDisconnect            = 0x0ca;

setting_implicitConnectTimeout_ms = 0x0a0;

setting_prefixWithSymbology       = 0x0d7;
noSymbologyPrefix                 = 0;
symbologyPrefix                   = 1;
symbologyAndModifierPrefix        = 2;


setting_connectTimeout_sec        = 0x0d9;
setting_prefixWithQuality         = 0x0da;
setting_reconnectTimeout_sec      = 0x0ea;
setting_enableSymbologyIdentifierPrefix = 0x0ed;
setting_noStoreIfNotConnected     = 0x0b4;

setting_commProtocol              = 0x008;
commProtocolRaw                   = 0x001;

setting_disableRunCommand         = 0x110;
setting_disableConfigMenu         = 0x111;
setting_disableDeleteOption       = 0x112;

setting_synchronousSend           = 0x150;

setting_rfAutoSaveActiveConnection= 0x172;

setting_activeRfConnection        = 0x07a;

setting_sleepGoodLedPattern       = 0x237;
setting_sleepGoodLedSyncPosition  = 0x238;
setting_sleepErrorLedPattern      = 0x239;
setting_sleepErrorLedSyncPosition = 0x23a;
setting_sleepDataLedPattern       = 0x23b;
setting_sleepDataLedSyncPosition  = 0x23c;
setting_sleepWirelessLedPattern   = 0x23d;
setting_sleepWirelessLedSyncPosition = 0x23e;
setting_sleepBatteryLedPattern    = 0x23f;
setting_sleepBatteryLedSyncPosition = 0x240;
setting_maxBufferedQueueSize      = 0x253;
setting_activeBtKbConnection      = 0x25c;
setting_useDemoScript             = 0x02a8;

// NOTE: If this bitmap changes, needs to change
// in decoder.h also
setting_decodingExtras            = 0x24f;
forceUpperCase                    = 0x00004;
forceLowerCase                    = 0x00008;
removeGS1DatabarParens            = 0x08000;



//Events
event_cradled                     = 0xE0;
event_uncradled                   = 0xDF;
event_paging                      = 0x2F;
event_appleMode                   = 0xF1;

// File system values
currDir                   = 0;
decoderDir                = 1;


/*eof*/
