/* .startup.js
 * shows splash screen and runs default application
 *
 * $Revision: 7022 $
 */

include(".settings.js");

var DemoStarted = false;

if( storage.read("logo.img") )
{
    gui.splash("logo.img",
              "v" + reader.softwareVersion.substr(0, 4)
            + "/" + reader.softwareVersion.substr(4, 4)
            + "/" + reader.softwareVersion.substr(8, 4)
        );
    //we can not block while js engine is running, since its not a separate thread
    //We create a timer here and let the image be displayed for the set duration.
    //run the default script after timer expires.
    setTimeout(runDefault, 5000);
}
else
{
    runDefault();
}

function runDefault()
{
    gui.clearSplash();
	if(reader.hasDisplay && reader.readSetting(setting_useDemoScript))
	{
		if(reader.runScript(".defaultDemo.js"))
		{
			DemoStarted = true;
			// Increase the timeout to give a chance to see the selections
			reader.writeSetting(setting_backlightTimeout_ms, 30000);
		}
	}
    if(!DemoStarted)
	{
		if( !reader.runScript(".default.js") )
		{
			gui.show(new gui.Text("Installation problem: bad or missing default application"));
		}
	}
}


// eof
