/* Filename:    J008_onDecodeOverload.js
 * Description: OnDecode overload example (to modify decode data)
 * Copyright:   2014 The Code Corporation.  All rights are reserved.
 * $Revision: 636 $
 * $Date: 2014-02-26 17:24:04 -0700 (Wed, 26 Feb 2014) $
 */
 
if(storage.read(".crx.js")) //Running on the CR3500 Hardware
    include(".crx.js");
if(storage.read(".cre.js")) //Running on the CR3600 Hardware
    include(".cre.js");

reader.onDecodeOld = reader.onDecode;

reader.onDecode = function(decode)
{
    if( decode.data.substr(0, 3) == "abc" ) // Matches for data begining with abc
    {
        //remove the "abc" from the beginning
        decode.data = decode.data.substr(3);
        
        //replace all Z chars with DE with a regular expression
        re = /Z/g;
        decode.data = decode.data.replace(re, "DE"); 
        
        //after 1st 5 char add CDE, add rest of the data starting at the 7th char
        decode.data = decode.data.substr(0,5) + "CDE" + decode.data.substr(6);
    }
    
     return reader.onDecodeOld(decode); //let the original onDecode function handle everything else.
}

//EOF