/* Filename:    J009_Tradshow.js
 * Description: Tradeshow Application (doesn't actually store the leads)
 *
 *              In the simulator, enter data in this format:
 *
 *                 First Last, Company
 *
 *                 John Brown, Code
 *
 * Copyright:   2014 The Code Corporation.  All rights are reserved.
 * $Revision: 636 $
 * $Date: 2014-02-26 17:24:04 -0700 (Wed, 26 Feb 2014) $
 */
 
if(storage.read(".crx.js")) //Running on the CR3500 Hardware
    include(".crx.js");
if(storage.read(".cre.js")) //Running on the CR3600 Hardware
    include(".cre.js");

// Constants
var sepHeight  = 2;

// Variables
var count = 0;
ready =  new gui.Text("");

ready.show = function(text)
{
    this.text = text? text: "Ready";
    gui.showDialog(this);
}

reader.onDecode = function(decode)
{  
    var scannedFields = decode.data.split(",");
    var nameFields    = scannedFields[0].split(" ");
    
    var fName   = nameFields[0];
    var lName   = nameFields[1];
    var company = scannedFields[1];
    re = /\s/g; // regular expression to find whitespace globally
    company = company.replace(re, ""); // replace whitespace with nothing in company field

    if( !fName || !lName || !company )
        ready.show("unrecognized format");
    else
    {
        ++count;
        ready.caption = "Leads: " + count;
         
        ready.show(fName + " " + lName + "\n" + company);
    }
}

ready.onCancel = function()
{
    reader.runScript(".default.js");
}

ready.caption = "Leads: " + count;
ready.show();

//EOF
