/* Filename:    J011_buildForm.js
 * Description: Building and showing form on Gui -
 *              By putting the form creation in a function, you can display interactive
 *                  text on the screen.
 *
 * Copyright:   2014 The Code Corporation.  All rights are reserved.
 * $Revision: 636 $
 * $Date: 2014-02-26 17:24:04 -0700 (Wed, 26 Feb 2014) $
 */
 
 // Global value to re-use on each form creation
 var lastText = "";
 
function showMain()
{
    function editData_Enter()
    {
        lastText      = editData.text;
        editData.text = "";
        showMain();
    }

    function editData_Clear()
    {
        lastText      = "";
        editData.text = "";
        showMain();
    }

    var frmForm1  = new gui.Form(editData_Enter, editData_Clear);
    var editData  = new gui.Edit("", gui.inputMode.numeric, gui.inputMode.numeric);

    //main code puts controls on screen in this order
    frmForm1.append(new gui.Label("Enter number"));
    frmForm1.append(editData);
    
    if (lastText != "")
    {
        frmForm1.append(new gui.Label("Last number"));
        frmForm1.append(new gui.Label(lastText));
    }

    gui.showForm(frmForm1); // Write form to screen
}

showMain(); // Call a new instance of the form, using global data

//EOF
