	/* Filename:    dRunDemo.js
	 * Description: This application demonstrate the capability of the CS3600 in an event settings such as concerts, clubs, etc.
	 *              When the system boots, the user will be able to enter demo mode to test functionalities that are capabile
	 *              with the 3600 system.
	 * Copyright:   2013 The Code Corporation. All rights are reserved.
	 * $Title: Pre-installation $
	 * $Revision: 1.0 $
	 * $Date: 2013-10-21 09:34:52 $
	 * $Author: Dthai
	 */

	include(".cre.js");

	//Override ready.show
	ready.oldShow = ready.show;
	ready.show = function(text, busy)
	{
		//Do nothing for demo script
	}

	/* Data variables for splash screen */
	var isInit = true;
	var demoSplash = "";

	if (isInit)
	{
		if(storage.read("demologo.img"))
		{
		 gui.splash( "demologo.img"); //function created for the 3600
		 setTimeout(loadSplash, 3000);
		}
		else
		{
			loadSplash();
		}

	}
	/* Loads the exit demo screen */
	function loadExit()
	{
		 var splashExit = new gui.Menu;
		 splashExit.caption = "Exit Apps?";
		 splashExit.leftSoftkey = new gui.Softkey ("Yes", onDemoCancel);
		 splashExit.rightSoftkey = new gui.Softkey ("No", function() { menu = demoSplash; gui.showDialog(menu);});
		 gui.showDialog(splashExit);
	}

	/* Exits the demo splash screen and returns to the barcodes default js file */
	function onDemoCancel()
	{
		//reset useDemoScript setting.
		reader.processCommand("C", "(" + setting_useDemoScript.toString(16) + ")0");
		reader.runScript(".default.js");
	}

	/* Loads the demo options screen */
	function loadOptions()
	{
		 reader.runScript(".dOptions.js");
	}

	/* Load the splash intro */
	function loadSplash()
	{
		 gui.clearSplash(); // call this statement inside the cfuntion to clear the splash.
		 demoSplash = new gui.Menu();
		 demoSplash.leftSoftkey             = new gui.Softkey  ("Start", function() {loadOptions();});
		 demoSplash.rightSoftkey            = new gui.Softkey  ("Exit", function() {loadExit();});
		 demoSplash.append                   (new gui.Label	("Welcome to" ));
		 demoSplash.append                   (new gui.Label	("the CR3600"));
		 demoSplash.append                   (new gui.Label	("pre-installed"));
		 demoSplash.append                   (new gui.Label	("applications."));
		 demoSplash.append                   (new gui.Label	("The following"));
		 demoSplash.append                   (new gui.Label	("ID"));
		 demoSplash.append                   (new gui.Label	("verification, "));
		 demoSplash.append                   (new gui.Label	("inventory, and"));
		 demoSplash.append                   (new gui.Label	("events/"));
		 demoSplash.append                   (new gui.Label	("tradeshow"));
		 demoSplash.append                   (new gui.Label	("applications"));
		 demoSplash.append                   (new gui.Label  	("demonstrate"));
		 demoSplash.append                   (new gui.Label	("some of the"));
		 demoSplash.append                   (new gui.Label	("capabilities of"));
		 demoSplash.append                   (new gui.Label	("the CR3600."));
		 demoSplash.append                   (new gui.Label	("The user"));
		 demoSplash.append                   (new gui.Label	("manual can be" ));
		 demoSplash.append                   (new gui.Label	("found on the"));
		 demoSplash.append                   (new gui.Label	("Code website"));
		 demoSplash.append                   (new gui.Label	("at www."));
		 demoSplash.append                   (new gui.Label	("codecorp.com"));
		 gui.showDialog(demoSplash);
	}


